Skip to navigation

Execute an invoice schedule

View as Markdown

Executes an invoice schedule immediately. During the execution, a bill run is created and generates an invoice or a credit memo asynchronously.

When you use this API operation to execute an invoice schedule item, you have the flexibility to decide whether to specify a specific item ID.

  • If you specify the unique ID of an invoice schedule item to be executed in the request, the corresponding invoice schedule item is executed.
  • If you do not specify the ID of any invoice schedule item in the request, the subscription end date is used as the target date to determine the next pending schedule item to be executed.

A paused invoice schedule and charges inside cannot be automatically executed by Zuora Scheduler or by this “Execute an invoice schedule” API operation. In this case, you can do one of the following:

For more samples, see Execute invoice schedules.

Note: This operation is available only if you have the Billing Schedule feature enabled.

Authentication

AuthorizationBearer

Use Bearer {{token}} in the Authorization header for authentication.

Path parameters

scheduleKeystringRequired

The unique ID or number of the schedule to be executed. For example, 2c92c8955bd63cc1015bd7c151af02ab or IS-0000001.

Headers

Idempotency-KeystringOptional<=255 characters
Specify a unique idempotency key if you want to perform an idempotent POST or PATCH request. Do not use this header in other request types. With this header specified, the Zuora server can identify subsequent retries of the same request using this value, which prevents the same operation from being performed multiple times by accident.
Accept-EncodingstringOptional

Include the Accept-Encoding: gzip header to compress responses as a gzipped file. It can significantly reduce the bandwidth required for a response.

If specified, Zuora automatically compresses responses that contain over 1000 bytes of data, and the response contains a Content-Encoding header with the compression algorithm so that your client can decompress it.

Content-EncodingstringOptional

Include the Content-Encoding: gzip header to compress a request. With this header specified, you should upload a gzipped file for the request payload instead of sending the JSON payload.

Zuora-Track-IdstringOptional<=64 characters

A custom identifier for tracing the API call. If you set a value for this header, Zuora returns the same value in the response headers. This header enables you to associate your system process identifiers with Zuora API calls, to assist with troubleshooting in the event of an issue.

The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (:), semicolon (;), double quote ("), and quote (').

Zuora-Entity-IdsstringOptional

An entity ID. If you have Zuora Multi-entity enabled and the OAuth token is valid for more than one entity, you must use this header to specify which entity to perform the operation in. If the OAuth token is only valid for a single entity, or you do not have Zuora Multi-entity enabled, you should not set this header.

Zuora-Org-IdsstringOptional

Comma separated IDs. If you have Zuora Multi-Org enabled, you can use this header to specify which orgs to perform the operation in. If you do not have Zuora Multi-Org enabled, you should not set this header.

The IDs must be a sub-set of the user’s accessible orgs. If you specify an org that the user does not have access to, the operation fails. This header is important in Multi-Org (MO) setups because it defines the organization context under which the API should operate—mainly used for read access or data visibility filtering. If the header is not set, the operation is performed in scope of the user’s accessible orgs.

Zuora-VersionstringOptional

The minor API version.

For a list of available minor versions, see API upgrades.

Request

This endpoint expects an object.
scheduleItemIdstringOptional
The ID of the invoice schedule item to be executed. The item must be the earliest pending schedule item. If all the invoice schedule items have been processed and credit is needed to be generated, do not specify this field in the request.

Response headers

Content-EncodingstringOptional

This header is returned if you specify the Accept-Encoding: gzip request header and the response contains over 1000 bytes of data.

Note that only the following MIME types support gzipped responses:

  • application/json
  • application/xml
  • text/html
  • text/csv
  • text/plain
RateLimit-LimitstringOptional

The request limit quota for the time window closest to exhaustion. See rate limits for more information.

RateLimit-Remainingdouble

The number of requests remaining in the time window closest to quota exhaustion. See rate limits for more information.

RateLimit-Resetdouble

The number of seconds until the quota resets for the time window closest to quota exhaustion. See rate limits for more information.

Zuora-Request-IdstringOptional
The Zuora internal identifier of the API call. You cannot control the value of this header.
Zuora-Track-IdstringOptional
A custom identifier for tracing the API call. If you specified a tracing identifier in the request headers, Zuora returns the same tracing identifier. Otherwise, Zuora does not set this header.
Concurrency-Limit-TypestringOptional

The type of the concurrency limit, which can be Default, High-volume transactions, or Object Query.

For more information, see Concurrent request limits.

Concurrency-Limit-Limitinteger

The total number of the permitted concurrent requests.

For more information, see Concurrent request limits.

Concurrency-Limit-Remaininginteger

The remaining number of the permitted concurrent requests.

For more information, see Concurrent request limits.

Response

OK
autoEmailbooleanOptional

Whether to automatically send an email after Auto-Post is complete.

autoPostbooleanOptional
Whether to automatically post the bill run after the bill run is created.
autoRenewalbooleanOptional

Whether to automatically renew auto-renew subscriptions that are up for renewal.

batcheslist of stringsOptional

A list of the batches of accounts for this bill run.

This field cannot exist with the billRunFilters field.

Values: AllBatches or Batchn where n is a number between 1 and 50, for example, Batch7.

billCycleDaystringOptional

The day of the bill cycle, this field is only valid when batches is specified.

Values:

  • AllBillCycleDays or 1 - 31 for an ad-hoc bill run
  • AllBillCycleDays or 1 - 31 or AsRunDay for a scheduled bill run
billRunFilterslist of objectsOptional

A list of the target account or subscriptions for this bill run.

This field cannot exist with the batches field.

billRunNumberstringOptional
The number of bill run.
chargeTypeToExcludelist of enumsOptional
The types of the charges to be excluded from the generation of billing documents.
Allowed values:
createdByIdstringOptional
The ID of the user who created the bill run.
createdDatestringOptional
The date and time when the bill run was created.
idstringOptional
The unique ID of the bill run.
invoiceDatedateOptional

The invoice date for this bill run, only valid for ad-hoc bill runs.

invoiceDateOffsetintegerOptional
The offset compared to bill run execution date, only valid for scheduled bill runs.
noEmailForZeroAmountInvoicebooleanOptional

Whether to suppress emails for invoices with the total amount of zero or not for this bill run after the bill run is complete.

Note: Do not email invoices with the total amount of zero.

organizationLabelslist of objectsOptional

The organization(s) that the object belongs to.

Note: This field is available only when the Multi-Org feature is enabled.

scheduledExecutionTimestringOptional
The scheduled execution time for a bill run.
statusenumOptional
The status of the bill run.
targetDatedateOptional

The target date for this bill run, only valid for ad-hoc bill run.

targetDateOffsetintegerOptional
The offset compared to bill run execution date, only valid for scheduled bill run.
updatedByIdstringOptional
The ID of the user who updated the bill run.
updatedDatestringOptional
The date and time when the bill run was updated.

Errors

4XX
Client Request Error
500
Internal Server Error